## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1
%bcond_without check
%bcond_without bootstrap

# https://github.com/google/go-cloud
%global goipath         gocloud.dev
%global forgeurl        https://github.com/google/go-cloud
Version:                0.24.0
Epoch:                  1

%gometa

%global goipaths0       gocloud.dev
%global goipathsex0     gocloud.dev/secrets/hashivault

%if %{without bootstrap}
%global goipaths1       gocloud.dev/secrets/hashivault
%endif

%global common_description %{expand:
The Go Cloud Development Kit (Go CDK) allows Go application developers to
seamlessly deploy cloud applications on any combination of cloud providers. It
does this by providing stable, idiomatic interfaces for common uses like storage
and databases. Think database/sql for cloud products.}

%global golicenses      LICENSE
%global godocs          AUTHORS CODE_OF_CONDUCT.md CONTRIBUTING.md\\\
                        CONTRIBUTORS README.md

Name:           %{goname}
Release:        %autorelease
Summary:        Library and tools for open cloud development in Go

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}
# To use etcd 3.5.0 and newer
Patch0:         0001-Fix-to-use-latest-etcd.patch
Patch1:         0002-Fix-bool.patch

BuildRequires:  golang(cloud.google.com/go/compute/metadata)
BuildRequires:  golang(cloud.google.com/go/firestore/apiv1)
BuildRequires:  golang(cloud.google.com/go/iam/credentials/apiv1)
BuildRequires:  golang(cloud.google.com/go/kms/apiv1)
BuildRequires:  golang(cloud.google.com/go/pubsub/apiv1)
BuildRequires:  golang(cloud.google.com/go/secretmanager/apiv1)
BuildRequires:  golang(cloud.google.com/go/storage)
BuildRequires:  golang(contrib.go.opencensus.io/exporter/aws)
BuildRequires:  golang(contrib.go.opencensus.io/exporter/stackdriver)
BuildRequires:  golang(contrib.go.opencensus.io/exporter/stackdriver/monitoredresource)
BuildRequires:  golang(contrib.go.opencensus.io/integrations/ocsql)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/aws)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/config)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/credentials)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/service/kms)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/service/secretsmanager)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/service/ssm)
BuildRequires:  golang(github.com/aws/aws-sdk-go-v2/service/ssm/types)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/awserr)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/client)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/credentials)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/request)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/session)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/dynamodb)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/dynamodb/expression)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/kms)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/s3)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/s3/s3manager)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/secretsmanager)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/sns)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/sqs)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/ssm)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/xray)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/xray/xrayiface)
BuildRequires:  golang(github.com/aws/smithy-go)
BuildRequires:  golang(github.com/Azure/azure-amqp-common-go/v3)
BuildRequires:  golang(github.com/Azure/azure-amqp-common-go/v3/uuid)
BuildRequires:  golang(github.com/Azure/azure-pipeline-go/pipeline)
BuildRequires:  golang(github.com/Azure/azure-sdk-for-go/services/keyvault/v7.0/keyvault)
BuildRequires:  golang(github.com/Azure/azure-service-bus-go)
BuildRequires:  golang(github.com/Azure/azure-storage-blob-go/azblob)
BuildRequires:  golang(github.com/Azure/go-amqp)
BuildRequires:  golang(github.com/Azure/go-autorest/autorest)
BuildRequires:  golang(github.com/Azure/go-autorest/autorest/adal)
BuildRequires:  golang(github.com/Azure/go-autorest/autorest/azure)
BuildRequires:  golang(github.com/Azure/go-autorest/autorest/azure/auth)
BuildRequires:  golang(github.com/fsnotify/fsnotify)
BuildRequires:  golang(github.com/go-sql-driver/mysql)
BuildRequires:  golang(github.com/golang/protobuf/proto)
BuildRequires:  golang(github.com/golang/protobuf/ptypes)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/timestamp)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/wrappers)
BuildRequires:  golang(github.com/google/go-cmp/cmp)
BuildRequires:  golang(github.com/google/go-cmp/cmp/cmpopts)
BuildRequires:  golang(github.com/google/go-replayers/grpcreplay)
BuildRequires:  golang(github.com/google/go-replayers/httpreplay)
BuildRequires:  golang(github.com/google/go-replayers/httpreplay/google)
BuildRequires:  golang(github.com/google/subcommands)
BuildRequires:  golang(github.com/google/uuid)
BuildRequires:  golang(github.com/google/wire)
BuildRequires:  golang(github.com/googleapis/gax-go/v2)
BuildRequires:  golang(github.com/GoogleCloudPlatform/cloudsql-proxy/proxy/certs)
BuildRequires:  golang(github.com/GoogleCloudPlatform/cloudsql-proxy/proxy/proxy)
BuildRequires:  golang(github.com/gorilla/mux)
%if %{without bootstrap}
BuildRequires:  golang(github.com/hashicorp/vault/api)
%endif
BuildRequires:  golang(github.com/lib/pq)
BuildRequires:  golang(github.com/nats-io/nats.go)
BuildRequires:  golang(github.com/Shopify/sarama)
BuildRequires:  golang(github.com/streadway/amqp)
BuildRequires:  golang(go.etcd.io/etcd/client/v3)
BuildRequires:  golang(go.etcd.io/etcd/api/v3/v3rpc/rpctypes)
BuildRequires:  golang(go.mongodb.org/mongo-driver/bson)
BuildRequires:  golang(go.mongodb.org/mongo-driver/bson/primitive)
BuildRequires:  golang(go.mongodb.org/mongo-driver/mongo)
BuildRequires:  golang(go.mongodb.org/mongo-driver/mongo/options)
BuildRequires:  golang(go.opencensus.io/plugin/ocgrpc)
BuildRequires:  golang(go.opencensus.io/plugin/ochttp)
BuildRequires:  golang(go.opencensus.io/stats)
BuildRequires:  golang(go.opencensus.io/stats/view)
BuildRequires:  golang(go.opencensus.io/tag)
BuildRequires:  golang(go.opencensus.io/trace)
BuildRequires:  golang(golang.org/x/crypto/nacl/secretbox)
BuildRequires:  golang(golang.org/x/net/context/ctxhttp)
BuildRequires:  golang(golang.org/x/oauth2)
BuildRequires:  golang(golang.org/x/oauth2/google)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(golang.org/x/tools/go/packages)
BuildRequires:  golang(golang.org/x/xerrors)
BuildRequires:  golang(google.golang.org/api/googleapi)
BuildRequires:  golang(google.golang.org/api/iterator)
BuildRequires:  golang(google.golang.org/api/option)
BuildRequires:  golang(google.golang.org/genproto/googleapis/cloud/kms/v1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/cloud/runtimeconfig/v1beta1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/cloud/secretmanager/v1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/firestore/v1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/iam/credentials/v1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/pubsub/v1)
BuildRequires:  golang(google.golang.org/genproto/googleapis/type/latlng)
BuildRequires:  golang(google.golang.org/grpc)
BuildRequires:  golang(google.golang.org/grpc/codes)
BuildRequires:  golang(google.golang.org/grpc/credentials)
BuildRequires:  golang(google.golang.org/grpc/credentials/oauth)
BuildRequires:  golang(google.golang.org/grpc/metadata)
BuildRequires:  golang(google.golang.org/grpc/status)
BuildRequires:  golang(gopkg.in/pipe.v2)

%if %{with check}
# Tests
BuildRequires:  golang(cloud.google.com/go/firestore)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/dynamodb/dynamodbattribute)
BuildRequires:  golang(github.com/google/go-cmdtest)
BuildRequires:  golang(github.com/nats-io/nats-server/v2/server)
BuildRequires:  golang(github.com/nats-io/nats-server/v2/test)
BuildRequires:  golang(golang.org/x/tools/go/packages/packagestest)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1

%install
%gopkginstall

%if %{with check}
%check
# Up to and including secrets/gcpkms requires network, according to previous maintainer.
%gocheck %{?with_bootstrap:-d secrets/hashivault} \
         %{?with_bootstrap:-d samples/gocdk-secrets} \
         -d docstore/mongodocstore \
         -d internal/cmd/gocdk \
         -d pubsub/gcppubsub \
         -d pubsub/kafkapubsub \
         -d pubsub/rabbitpubsub \
         -d runtimevar/etcdvar \
         -d samples/gocdk-pubsub \
         -d blob/azureblob \
         -d blob/gcsblob \
         -d secrets/gcpkms
%endif

%gopkgfiles

%changelog
* Wed Jul 26 2023 W. Michael Petullo <mike@flyn.org> - 1:0.24.0-2
- Use %%autopatch -p1

* Wed Jul 26 2023 W. Michael Petullo <mike@flyn.org> - 1:0.24.0-1
- Bump epoch

* Sun Jul 23 2023 W. Michael Petullo <mike@flyn.org> - 0.24.0-1
- Downgrade back to 0.24.0

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.30.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jul 14 2023 W. Michael Petullo <mike@flyn.org> - 0.30.0-1
- Update to 0.30.0

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.24.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Aug 10 2022 Maxwell G <gotmax@e.email> - 0.24.0-4
- Rebuild to fix FTBFS

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.24.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.24.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Sep 17 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.24.0-1
- Update to 0.24.0 Close: rhbz#1925748, rhbz#1996417, rhbz#1996439

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.21.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.21.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Dec 22 06:40:41 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.21.0-1
- Update to 0.21.0
- Close: rhbz#1906345

* Wed Aug 05 14:12:52 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.20.0-1
- Update to 0.20.0

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.18.0-3
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.18.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Feb 05 00:21:13 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.18.0-1
- Update to 0.18.0

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Oct 23 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.17.0-2
- Backport fix for 32-bit tests

* Tue Aug 20 18:30:17 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0.17.0-1
- Initial package

